Redmine - Patch #38474

Preload default_status when listing trackers
2023-04-20 03:30 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Performance Estimated time: 0.00 hour
Target version: 5.1.0

Description

The patch fixes N+1 issue in TrackersController#index.

diff --git a/app/controllers/trackers_controller.rb b/app/controllers/trackers_controller.rb
index 64367£f373..05ef336ef 100644
-—— a/app/controllers/trackers_controller.rb
+++ b/app/controllers/trackers_controller.rb
@@ -26,7 +26,7 @@ class TrackersController < ApplicationController
accept_api_auth :index

def index
= Qtrackers = Tracker.sorted.to_a
+ @trackers = Tracker.sorted.preload(:default_status) .to_a
respond_to do |format|
format.html {render :layout => false if request.xhr?}
format.api

Before:
Tracker Load (0.1ms) SELECT "trackers".* FROM "trackers" ORDER BY "trackers"."position" ASC

L app/controllers/trackers_controller.rb:29:in "~ index'
Rendering trackers/index.api.rsb

IssueStatus Load (0.1ms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_statuses"
."id" = ? LIMIT ? [["id", 1], ["LIMIT", 1]]

L app/views/trackers/index.api.rsb:6

IssueStatus Load (0.1ms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_statuses"
."id" = ? LIMIT 2 [["id", 2], ["LIMIT", 11]

L app/views/trackers/index.api.rsb:6

CACHE IssueStatus Load (0.0ms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_sta
tuses"."id" = ? LIMIT °? rgrid", 11, ["LIMIT", 11]

L app/views/trackers/index.api.rsb:6

CACHE IssueStatus Load (0.0ms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_sta
tuses"."id" = ? LIMIT ? [["id", 1], ["LIMIT", 1]]

L app/views/trackers/index.api.rsb:6

CACHE IssueStatus Load (0.0ms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_sta

tuses"."id" = ? LIMIT °? (g"id", 21, ["LIMIT", 1]]

L app/views/trackers/index.api.rsb:6

IssueStatus Load (0.1ms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_statuses"
."id" = ? LIMIT 2 [["id", 5], ["LIMIT", 1]]

L app/views/trackers/index.api.rsb:6

IssueStatus Load (0.1lms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_statuses"
."id" = ? LIMIT ? [["id", 3], ["LIMIT", 1]]

L app/views/trackers/index.api.rsb:6

After:

Tracker Load (0.2ms) SELECT "trackers".* FROM "trackers" ORDER BY "trackers"."position" ASC

L app/controllers/trackers_controller.rb:29:in " index'

IssueStatus Load (0.6ms) SELECT "issue_statuses".* FROM "issue_statuses" WHERE "issue_statuses"
."id" IN (2, ?, ?, ?) rg*id», 131, ["id", 231, ["id", 51, ["id", 311

L app/controllers/trackers_controller.rb:29:in "~ index'
Associated revisions

Revision 22208 - 2023-04-22 03:12 - Go MAEDA
Preload default_status when listing trackers (#38474).

Patch by Go MAEDA.

History

#1 - 2023-04-20 23:49 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0

Setting the target version to 5.1.0.

#2 - 2023-04-22 03:12 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch in r22208.
